package Calendar;

import java.util.Iterator;

public class Date implements Comparable<Date> , Iterable<Date>{
	private int day;
	private int month;
	private int year;
	
	private static int[] DaysInMonth = {31,28,31,30,31,30,31,30,30,31,30,31};
	public Date (int day, int month, int year) {
		if (isValid(day, month, year)) {
			this.day = day;
			this.month = month;
			this.year = year;
		} else {
			this.day = 1;
			this.month = 1;
			this.year = 2023;
		}
	}
	public Date (Date O) {
		this.day = O.day;
		this.month = O.month;
		this.year = O.year;
	}
	public Date(int year) {
		this.day = 1;
		this.month = 1;
		this.year = year;
	}
	private boolean isValid(int day, int month, int year) {
		if (month > 0 && month < 13) {
			if (day > 0 && day <= DaysInMonth[month-1]) {
				return true;
			}
		}
		return false;
	}
	@Override
	public int compareTo(Date o) {
		if (year == o.year) {
			if (month == o.month) {
				if (day == o.day) {
					return 0;
				} else if (day > o.day) {
					return 1;
				} else return -1;
			} else if (month > o.month) {
				return 1;
			} else return -1;
		} else if (year > o.year) {
			return 1;
		} else return -1;
	}
	@Override
	public Iterator<Date> iterator() {
		// TODO Auto-generated method stub
		return new Iterator<Date>() {
			int nextDay = day+1;
			@Override
			public boolean hasNext() {
				// TODO Auto-generated method stub
				return true;
			} //there's always the next day :P

			@Override
			public Date next() {
				if (isValid(nextDay,month,year)) {
					return new Date(nextDay,month,year);
					
				} else if (month < 12) {
					return new Date(1,++month,year);
					
				} else  {
					
					return new Date(1,1,year+1);
				}
			}
			
		};
	}
	public int getDay() {
		return day;
	}
	public int getMonth() {
		return month;
	}
	public int getYear() {
		return year;
	}
	public String toString() {
		return day + "/" + month + "/" + year;
	}
	public Date getPrec() {
		if (day == 1) {
			if (month == 1) {
				return new Date(DaysInMonth[11],12,year-1);
			} else {
				return new Date(DaysInMonth[month-2],month-1,year);
			}
		} else {
			return new Date(day-1,month,year);
		}
	}
	
	
}
