package Calendar;

import java.util.Iterator;
import java.util.TreeSet;

public class Month implements Iterable<Month>,Comparable<Month>{
	
	private Months name;
	private int ordinal;
	private Date First;
	private TreeSet<Week> Weeks = new TreeSet<>();
	private static int[] DaysInMonth = {31,28,31,30,31,30,31,30,30,31,30,31};
	
	
	public Month (int year, int ordinal, Days firstDay) {
		this.First = new Date(1,ordinal,year);
		this.ordinal = ordinal;
		name = Months.values()[ordinal-1];
		Date tmpDate = new Date(First);
		Week tmpWeek  = new Week(tmpDate,firstDay.ordinal()+1);
		Weeks.add(tmpWeek);
		do {
			
			tmpWeek = tmpWeek.iterator().next();
			tmpDate = tmpWeek.getWeekDays().last().getDate();
			Weeks.add(tmpWeek);
			
			
		}while(tmpDate.getDay()<DaysInMonth[ordinal-1]);
	}
	public TreeSet<Week> getWeeks() {
		return Weeks;
	}

	@Override
	public int compareTo(Month o) {
		// TODO Auto-generated method stub
		return First.compareTo(o.First);
	}

	@Override
	public Iterator<Month> iterator() {
		// TODO Auto-generated method stub
		return new Iterator<Month>() {

			@Override
			public boolean hasNext() {
				// There's always a next month
				return true;
			}

			@Override
			public Month next() {
				if (ordinal == 12) {
					return new Month(First.getYear()+1,1,Weeks.last().getWeekDays().last().getName());
				} else {
					return new Month(First.getYear(),ordinal+1,Days.values()[(Weeks.last().getWeekDays().last().getName().ordinal()+1)%7]);
				}
				
			}
			
		};
	}
	
	public Date getDate() {
		return First;
	}
	
	public Months getName() {
		return name;
	}
	public String toString() {
		
		String out = name.toString()+":\n";
		for (Week W: Weeks) {
			out +="\t" + W.toString()+ "\n";
		}
		
		return out;
	}

}
